Bug 45131 - Array of double*[] being treated as non-blittable when marshaled
Summary: Array of double*[] being treated as non-blittable when marshaled
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: Interop (show other bugs)
Version: unspecified
Hardware: All Linux
: --- normal
Target Milestone: ---
Assignee: Bugzilla
URL:
Depends on:
Blocks:
 
Reported: 2016-10-06 18:06 UTC by Neale Ferguson
Modified: 2016-10-07 18:21 UTC (History)
4 users (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
Simple test case (912 bytes, text/plain)
2016-10-06 18:06 UTC, Neale Ferguson
Details
Sample test case code (559 bytes, text/x-csrc)
2016-10-06 18:07 UTC, Neale Ferguson
Details

Description Neale Ferguson 2016-10-06 18:06:16 UTC
Created attachment 17913 [details]
Simple test case

When doing an interop call and trying to access a pinned c# array of double* in c++ we get a segment fault. A test case is attached. Research reveals that the behaviour of the marshaling of double*[] has changed between 4.4 and 4.5/4.6/... In 4.4 the element class is classified as "blittable" but not in the affected levels of code. The marshaling code generated is very different and results in a SEGV.
Comment 1 Neale Ferguson 2016-10-06 18:07:21 UTC
Created attachment 17914 [details]
Sample test case code

C code containing the call to which the double*[] is marshalled.
Comment 2 Zoltan Varga 2016-10-07 02:09:23 UTC
https://github.com/mono/mono/pull/3735
Comment 3 Zoltan Varga 2016-10-07 18:21:26 UTC
-> FIXED.

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.